// Copyright (c) 2024 Celestino Amoroso (celestino.amoroso@gmail.com).
// All rights reserved.

// t_expr_test.go
package expr

import (
	"testing"
)

func TestExpr(t *testing.T) {
	section := "Expr"

	inputs := []inputType{
		/*   1 */ {`0?{}`, nil, nil},
		/*   2 */ {`fact=func(n){(n)?{1}::{n*fact(n-1)}}; fact(5)`, int64(120), nil},
		/*   3 */ {`builtin "os.file"; f=fileOpen("test-file.txt"); line=fileReadText(f); fileClose(f); line`, "uno", nil},
		/*   4 */ {`mynot=func(v){int(v)?{true}::{false}}; mynot(0)`, true, nil},
		/*   5 */ {`1 ? {1} : [1+0] {3*(1+1)}`, int64(6), nil},
		/*   6 */ {`
		ds={
			"init":func(end){@end=end; @current=0 but true},
			"current":func(){current},
			"next":func(){
				((next=current+1) <= end) ? [true] {@current=next but current} :: {nil}
			}
		};
		it=$(ds,3);
		it++;
		it++
`, int64(1), nil},
	}
	// t.Setenv("EXPR_PATH", ".")

	// parserTestSpec(t, section, inputs, 3)
	runTestSuite(t, section, inputs)
}
